## Script (Python) "pct_add_object.py"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=template=None
##title=
##

from random import random

template = context.restrictedTraverse(template)
id = str(random())
context.invokeFactory(template.portal_type, id)
new_object = context[id]
for field in template.Schema().fields():
    field_name = field.getName()
    if field_name in ('id', 'creators', 'contributors',
	'creation_date', 'modification_date',
	# Something stupid..
	'eventType'): continue
    if field_name == 'subject':
        copy = ()
        for value in field.getAccessor(template)():
            if value != 'content-template':
                copy += (value,)
        if copy:
            new_object.setSubject(copy)
    else:
        field.getMutator(new_object)(field.getAccessor(template)())

context.REQUEST.RESPONSE.redirect(new_object.absolute_url() + '/base_edit')
